#include <stdio.h>
#include <tchar.h>
#include "../pdfx64_dll/pdffuncs.h"

#include <windows.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>
#include <windowsx.h> 
#include <math.h>

//define for VerySetFunction
#define Very_Set_MultiPage		101
#define Very_Set_ImagePosAndSize	104
#define Very_Set_Encrypt 		105
#define Very_Set_Font			106
#define Very_Set_NewOrClosePage		109
#define Very_Set_BookMark		110
#define Very_Set_ViewerPreferences	121
#define Very_Set_PageOrientation	122
#define Very_Set_Line_Dash		123
#define Very_Set_Line_Flat		124
#define Very_Set_Line_Join		125
#define Very_Set_Line_Cap		126
#define Very_Set_Line_MiterLimit	127

#define Very_Set_Link_BorderStyle	128
#define Very_Set_Link_BorderDash	129
#define Very_Set_Link_Web		130
#define Very_Set_Link_Local		132

#define Very_Set_Text_Matrix		133
#define Very_Set_Text_Leading		134
#define Very_Set_Text_Rise		135
#define Very_Set_Text_HorizScaling	136
#define Very_Set_Text_Rendering		137
#define Very_Set_Text_CharSpace		138
#define Very_Set_Text_WordSpace		139
#define Very_Set_Range			131

//define for VeryGetFunction
#define Very_Get_ImagePageCount		201
#define Very_Get_ImageSizeW		202
#define Very_Get_ImageSizeH		203
#define Very_Get_ImageDpiX		204
#define Very_Get_ImageDpiY		205
#define Very_Get_PdfPageCount		206
#define Very_Get_PdfCurrentPageSize	209
#define Very_Get_StringWidth		250
#define Very_Get_StringHeight		251
#define Very_Get_PageBoxForStamp	260

//define for VeryAddText
#define Very_DT_LEFT			0
#define Very_DT_CENTER			1
#define Very_DT_RIGHT			2
#define Very_DT_WORDBREAK		0x10
#define Very_DT_CALCRECT		0x400

void	GetModulePath(char *out_path,char *in_name);
BOOL	LoadVeryWDll(void);
void	FreeVeryWDll();


void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}

void AddTIFFImage(long id)
{
	char szImageFile[256];

	GetModulePath(szImageFile,"multipage.tif");
	//add bookmark
	int parentBookmark = VerySetFunction(id, Very_Set_BookMark, 0, 0,"bookmark one",0);
	
	//get multi page tiff page nums
	int pagenum=VeryGetFunction(id,Very_Get_ImagePageCount,0,0,szImageFile,0);
	if(pagenum>4)
	{
		//set multi page tiff convert
		int beginpage=2;
		int pagenums=2;
		VerySetFunction(id,Very_Set_MultiPage,beginpage,pagenums,0,0);
	}
	if(pagenum)
		VeryAddImage(id,szImageFile);
}
void AddWMFImage(long id)
{
	char szImageFile[256];

	GetModulePath(szImageFile,"test.wmf");
	VeryAddImage(id,szImageFile);
}
void AddJPGImage(long id)
{
	long width,height,xdpi,ydpi;
	char szImageFile[256];

	GetModulePath(szImageFile,"test1.jpg");
	//add bookmark
	VerySetFunction(id,Very_Set_BookMark,0,0,"bookmark two",0);
	int pagenum=VeryGetFunction(id,Very_Get_ImagePageCount,0,0,szImageFile,0);
	for(int i = 1; i <= pagenum; i++)
	{
		char buf[32];
		char buf2[32];
		long iret;
		width = VeryGetFunction(id,Very_Get_ImageSizeW,0,0,szImageFile,ltoa(i,buf,10));
		height = VeryGetFunction(id,Very_Get_ImageSizeW,0,0,szImageFile,ltoa(i,buf,10));
		//Get image dpi (Resolution)
		xdpi=VeryGetFunction(id,Very_Get_ImageDpiX,0,0,szImageFile,ltoa(i,buf,10));
		ydpi=VeryGetFunction(id,Very_Get_ImageDpiX,0,0,szImageFile,ltoa(i,buf,10));
		if(xdpi>0&&ydpi>0){
			width  = (long)(width * (72.0/xdpi));
			height = (long)(height* (72.0/ydpi));
		}
		//new page
		iret=VerySetFunction(id,Very_Set_NewOrClosePage,width,height,0,0);
		//set image size
		iret=VerySetFunction(id,Very_Set_ImagePosAndSize,0,0,ltoa(width,buf,10),ltoa(height,buf2,10));
		//add image one
		iret=VerySetFunction(id,Very_Set_MultiPage,i,1,0,0);
		iret=VeryAddImage(id,szImageFile);
		//close the page
		iret=VerySetFunction(id,Very_Set_NewOrClosePage,0,0,0,0);
	}
}
void AddText(long id)
{
	char* samp_text = "abcdefgABCDEFG12345!#$%&+-@?";
	int xx = 100;
	int yy = 180;
	//new a page for a3
	VerySetFunction(id,Very_Set_NewOrClosePage,1,1,0,0);
	//add bookmark
	int book1 = VerySetFunction(id,Very_Set_BookMark,0,0,"bookmark four-1",0);
		int book2 = VerySetFunction(id,Very_Set_BookMark,book1,0,"bookmark four-2",0);
			int book3 = VerySetFunction(id,Very_Set_BookMark,book2,0,"bookmark four-3",0);
				int book4 = VerySetFunction(id,Very_Set_BookMark,book3,0,"bookmark four-4",0);
		int book5 = VerySetFunction(id,Very_Set_BookMark,book1,0,"bookmark four-5",0);
	
	//set system font and size
	VerySetFunction(id,Very_Set_Font,100,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,101,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,102,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,103,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	
	VerySetFunction(id,Very_Set_Font,200,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,201,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,202,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,203,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));

	VerySetFunction(id,Very_Set_Font,300,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,301,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,302,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,303,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));

	VerySetFunction(id,Very_Set_Font,400,32,0,0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));

	yy+=40;
	VerySetFunction(id,Very_Set_Font,1,32,"Arial",0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,1,32,"Arial,Bold",0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,1,32,"Arial,Italic",0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,1,32,"Arial,Bold,Italic",0);
	VeryAddTextEx(id,xx,yy+=50,samp_text,RGB(0,0,0));

	//set font and size
	VerySetFunction(id,Very_Set_Font,203,32,0,0);
	
	{
		char string[]="Show text in this rectangle, show text in this rectangle.";
		//width =VeryGetFunction(id,Very_Get_StringWidth,0,0,string,0);
		//height=VeryGetFunction(id,Very_Get_StringHeight,0,0,string,0);
		//add text for rect
		int width = 200;  
		int height= 100;
		//VeryAddText(id,1,1,(long)&width,(long)&height,string,
		//	RGB(0,0,255),RGB(255,0,255),Very_DT_WORDBREAK|Very_DT_CALCRECT); 
		VeryAddText(id,1,1,width,height,string,
			RGB(0,0,255),RGB(255,0,255),Very_DT_WORDBREAK|Very_DT_CENTER); 
		//VeryAddText(id,1,1,width,height,string,
		//			 RGB(0,0,255),RGB(255,0,255),Very_DT_WORDBREAK|Very_DT_CENTER); 
	}

//#define Very_Set_Link_BorderDash		129
//#define Very_Set_Link_Web		130
//#define 		132

	VerySetFunction(id,Very_Set_Link_BorderStyle,0,2,0,0);//solid line, line width = 2
	VerySetFunction(id,Very_Set_Link_Web,RGB(255,0,0),0,"250,40,500,120","www.verypdf.com");
	VeryAddTextEx(id,260,50,"verypdf.com",RGB(0,0,0));

	VerySetFunction(id,Very_Set_Link_BorderStyle,1,2,0,0);//dash line, line width = 2
	VerySetFunction(id,Very_Set_Link_BorderDash,12,6,0,0);
	VerySetFunction(id,Very_Set_Link_Local,RGB(0,255,0),2,"250,150,500,230","fitpage");
	VeryAddTextEx(id,260,160,"Goto page 2",RGB(0,0,0));

	VerySetFunction(id,Very_Set_Link_BorderStyle,0,0,0,0);//solid line, line width = 2
	VerySetFunction(id,Very_Set_Link_Web,RGB(0,0,255),0,"520,40,770,120","mailto:support@verypdf.com");
	VeryAddTextEx(id,530,50,"E-mail",RGB(0,0,0));

	//Close this page
	VerySetFunction(id,Very_Set_NewOrClosePage,0,0,0,0);
}

void AddLineAndRect(long id)
{
	//new a page for b5
	VerySetFunction(id,Very_Set_NewOrClosePage,2,2,0,0);
	//add bookmark
	int parentBookmark0  = VerySetFunction(id, Very_Set_BookMark, 0, 0,"bookmark five:0",0);
		int parentBookmark1 = VerySetFunction(id,Very_Set_BookMark,parentBookmark0,0,"bookmark five:1",0);
			int parentBookmark2 = VerySetFunction(id,Very_Set_BookMark,parentBookmark1,0,"bookmark five:2",0);
		    parentBookmark1 = VerySetFunction(id,Very_Set_BookMark,parentBookmark0,0,"bookmark five:1-1",0);

	int pagewidth,pageheight;
	pagewidth = VeryGetFunction(id,Very_Get_PdfCurrentPageSize,0,0,0,0);
	pageheight = VeryGetFunction(id,Very_Get_PdfCurrentPageSize,0,0,0,0);
	VeryAddRect(id,20,20,pagewidth-20,pageheight-20,3,RGB(0,255,0),1,RGB(0xFC,0xFC,0xFC));

	int yy = 40;
	//add graphic
	VeryAddLine(id,30,yy,300,yy,1,RGB(0,0,0)); yy+=20;
	VeryAddLine(id,30,yy,300,yy,2,RGB(0,0,0)); yy+=20;
	VeryAddLine(id,30,yy,300,yy,4,RGB(0,0,0)); yy+=20;

	//dash
	VerySetFunction(id,Very_Set_Line_Dash,3,3,0,0);
	VeryAddLine(id,30,yy,300,yy,2,RGB(0,0,0)); yy+=20;

	VerySetFunction(id,Very_Set_Line_Dash,6,12,0,0);
	VeryAddLine(id,30,yy,300,yy,2,RGB(0,0,0)); yy+=20;

	VerySetFunction(id,Very_Set_Line_Dash,12,6,0,0);
	VeryAddLine(id,30,yy,300,yy,2,RGB(0,0,0)); yy+=20;

	//flat
	VerySetFunction(id,Very_Set_Line_Dash,24,12,0,0);
	VerySetFunction(id,Very_Set_Line_Flat,50,0,0,0);
	VeryAddLine(id,30,yy,300,yy,10,RGB(0,0,0)); yy+=60;

	//join
	VerySetFunction(id,Very_Set_Line_Dash,0,0,0,0);
	VerySetFunction(id,Very_Set_Line_Join,0,0,0,0);
	VeryAddLine(id,30 ,yy,150,yy-40,10,RGB(0,255,0));
	VeryAddLine(id,300,yy,150,yy-40,10,RGB(0,255,0)); yy+=60;

	VerySetFunction(id,Very_Set_Line_Cap,1,0,0,0);
	VerySetFunction(id,Very_Set_Line_Join,1,0,0,0);
	VeryAddLine(id,30 ,yy,150,yy-40,10,RGB(0,255,0));
	VeryAddLine(id,300,yy,150,yy-40,10,RGB(0,255,0)); yy+=60;

	VerySetFunction(id,Very_Set_Line_Cap,2,0,0,0);
	VerySetFunction(id,Very_Set_Line_Join,2,0,0,0);
	VeryAddLine(id,30 ,yy,150,yy-40,10,RGB(0,255,0));
	VeryAddLine(id,300,yy,150,yy-40,10,RGB(0,255,0)); yy+=20;

	//cap
	VerySetFunction(id,Very_Set_Line_Cap,0,0,0,0);
	VeryAddLine(id,30,yy,300,yy,10,RGB(0,0,255)); yy+=20;

	VerySetFunction(id,Very_Set_Line_Cap,1,0,0,0);
	VeryAddLine(id,30,yy,300,yy,10,RGB(0,0,255)); yy+=20;
	
	VerySetFunction(id,Very_Set_Line_Cap,2,0,0,0);
	VeryAddLine(id,30,yy,300,yy,10,RGB(0,0,255)); yy+=20;

	//Set to default style
	VerySetFunction(id,Very_Set_Line_Cap,0,0,0,0);
	VerySetFunction(id,Very_Set_Line_Join,0,0,0,0);

	//Rectangle
	yy = 40;
	VeryAddRect(id, 350, yy, 550,yy+40, 10, RGB(0,0,0),0,0); yy+=60;

	VerySetFunction(id,Very_Set_Line_Join,1,0,0,0);
	VeryAddRect(id, 350, yy, 550,yy+40, 10, RGB(0,0,0),0,0); yy+=60;

	VerySetFunction(id,Very_Set_Line_Join,0,0,0,0);
	VeryAddRect(id, 350, yy, 550,yy+40, 2, RGB(255,0,0),1,RGB(255,0,0)); yy+=60;

	VeryAddRect(id, 350, yy, 550,yy+40, 2, RGB(0,0,0),1,RGB(255,0,0)); yy+=100;

	//Circle
	VeryAddCircle(id, (350+550)/2, yy, 40, 2, RGB(0,0,0),0,RGB(255,0,0)); yy+=100;
	VeryAddCircle(id, (350+550)/2, yy, 40, 2, RGB(0,0,0),1,RGB(255,0,0)); yy+=100;

	//Ellipse
	VeryAddEllipse(id, 350, yy, 550,yy+40, 2, RGB(0,0,0),0,RGB(255,0,0)); yy+=100;
	VeryAddEllipse(id, 350, yy, 550,yy+40, 2, RGB(0,0,0),1,RGB(255,0,0)); yy+=100;

//	//Polygon
//	struct pdfshell2::POINT pt[6];
//	pt[0].x = 180;
//	pt[0].y = 420;
//	pt[1].x = pt[0].x-100;
//	pt[1].y = pt[0].y+50;
//	pt[2].x = pt[1].x+50;
//	pt[2].y = pt[1].y+100;
//	pt[3].x = pt[2].x+100;
//	pt[3].y = pt[2].y;
//	pt[4].x = pt[3].x+50;
//	pt[4].y = pt[3].y-100;
//	pt[5].x = pt[0].x;
//	pt[5].y = pt[0].y;
//	VeryAddPolygon(id, &pt[0], 6, 20, RGB(0,0,0),1,RGB(255,0,0)); yy+=100;
//
//	VerySetFunction(id,Very_Set_Line_Cap,1,0,0,0);
//	VerySetFunction(id,Very_Set_Line_Join,1,0,0,0);
//	pt[0].x = 180;
//	pt[0].y = 600;
//	pt[1].x = pt[0].x-100;
//	pt[1].y = pt[0].y+50;
//	pt[2].x = pt[1].x+50;
//	pt[2].y = pt[1].y+100;
//	pt[3].x = pt[2].x+100;
//	pt[3].y = pt[2].y;
//	pt[4].x = pt[3].x+50;
//	pt[4].y = pt[3].y-100;
//	pt[5].x = pt[0].x;
//	pt[5].y = pt[0].y;
//	VeryAddPolygon(id, &pt[0], 6, 20, RGB(0,0,0),1,RGB(255,0,0)); yy+=100;

//	VerySetFunction(id,Very_Set_Line_Cap,1,0,0,0);
//	VerySetFunction(id,Very_Set_Line_Join,2,0,0,0);
//	pt[0].x = 480;
//	pt[0].y = 600;
//	pt[1].x = pt[0].x-100;
//	pt[1].y = pt[0].y+50;
//	pt[2].x = pt[1].x+50;
//	pt[2].y = pt[1].y+100;
//	pt[3].x = pt[2].x+100;
//	pt[3].y = pt[2].y;
//	pt[4].x = pt[3].x+50;
//	pt[4].y = pt[3].y-100;
//	pt[5].x = pt[0].x;
//	pt[5].y = pt[0].y;
//	VeryAddPolygon(id, &pt[0], 6, 20, RGB(0,0,0),1,RGB(255,0,0)); yy+=100;

	VeryAddCurveTo(id, 0, pageheight, 86, pageheight-108, 201, pageheight-158, 216, pageheight-86, 5,RGB(0,0,255));

	//Close this page
	VerySetFunction(id,Very_Set_NewOrClosePage,0,0,0,0);
}
void AddTextFile(long id)
{
	char szImageFile[256];
	GetModulePath(szImageFile,"test.txt");
	VerySetFunction(id,Very_Set_Font,200,16,0,0);
	VeryAddTxt(id,szImageFile,0,0,0,1,1,64,64,64,64,4);
}
void AddTextExample2(long id)
{
	char* samp_text = "abcdefgABCDEFG12345!#$%&+-@?";
	int xx = 30;
	int yy = 50;

	//new page
	int iret=VerySetFunction(id,Very_Set_NewOrClosePage,2,2,0,0);

	int pagewidth,pageheight;
	pagewidth = VeryGetFunction(id,Very_Get_PdfCurrentPageSize,0,0,0,0);
	pageheight = VeryGetFunction(id,Very_Get_PdfCurrentPageSize,0,0,0,0);

	VerySetFunction(id,Very_Set_Font,1,32,"Times New Roman,Bold",0);
	VeryAddText(id,0,10,pagewidth,60,"Font Example 2",RGB(0,0,0),-1,Very_DT_CENTER);

	VerySetFunction(id,Very_Set_Font,300,8,0,0);
	VeryAddTextEx(id,xx,yy+=30,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,300,12,0,0);
	VeryAddTextEx(id,xx,yy+=30,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,300,18,0,0);
	VeryAddTextEx(id,xx,yy+=30,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,300,27,0,0);
	VeryAddTextEx(id,xx,yy+=30,samp_text,RGB(0,0,0));
	VerySetFunction(id,Very_Set_Font,300,40,0,0);
	VeryAddTextEx(id,xx,yy+=30,samp_text,RGB(0,0,0));


	VerySetFunction(id,Very_Set_Font,300,27,0,0);
	{
		// Rotating text
		float angle = 30.0;                   // A rotation of 30 degrees.
		float rad = float(angle / 180 * 3.141592); // Calcurate the radian value.
		char  szTextMatrix[200];
		sprintf(szTextMatrix,"%f,%f,%f,%f,%f,%f",cos(rad), sin(rad), -sin(rad), cos(rad), 0.0, 0.0);
		VerySetFunction(id,Very_Set_Text_Matrix,0,0,szTextMatrix,0);
		VeryAddTextEx(id,xx,yy+=150,"ABCabc123",RGB(255,0,0));
	}
	{
		// Skewing text
		float _angle1 = 10.0;
		float _angle2 = 20.0;
		float _rad1 = float(_angle1 / 180 * 3.141592);
		float _rad2 = float(_angle2 / 180 * 3.141592);

		float m2 = (float)tan(_rad1);
		float m3 = (float)tan(_rad2);
		char  szTextMatrix[200];
		sprintf(szTextMatrix,"%f,%f,%f,%f,%f,%f",1.0, m2, m3, 1.0, 0.0, 0.0);
		VerySetFunction(id,Very_Set_Text_Matrix,0,0,szTextMatrix,0);
		VeryAddTextEx(id,xx,yy+=100,"ABCabc123",RGB(0,255,0));
	}
	{
		// Scaling text (X direction)
		VerySetFunction(id,Very_Set_Text_Matrix,0,0,"1.5,0.0,0.0,1.0,0.0,0.0",0);
		VeryAddTextEx(id,xx,yy+=100,"ABCabc123",RGB(0,0,255));
		
		// Scaling text (Y direction)
		VerySetFunction(id,Very_Set_Text_Matrix,0,0,"1.0,0.0,0.0,2.0,0.0,0.0",0);
		VeryAddTextEx(id,xx,yy+=100,"ABCabc123",RGB(0,255,255));
	}
	xx = 250;
	yy = 250;
	VerySetFunction(id,Very_Set_Text_Matrix,0,0,"1,0,0,1,0,0",0);
	VeryAddTextEx(id,xx,yy,"ABCabc123",RGB(0,0,255));
	VerySetFunction(id,Very_Set_Text_Rise,10,0,0,0);
	VeryAddTextEx(id,-1,-1,"Rasing",RGB(0,0,255));
	
	yy += 50;
	VeryAddTextEx(id,xx,yy,"ABCabc123",RGB(0,0,255));
	VerySetFunction(id,Very_Set_Text_HorizScaling,50,0,0,0);
	VeryAddTextEx(id,-1,-1,"HorizScaling",RGB(0,0,255));

	yy += 50;
	VerySetFunction(id,Very_Set_Text_HorizScaling,100,0,0,0);
	VeryAddTextEx(id,xx,yy,"CharSpace",RGB(0,0,255));
	VerySetFunction(id,Very_Set_Text_CharSpace,10,0,0,0);
	VeryAddTextEx(id,-1,-1,"CharSpace",RGB(0,0,255));

	yy += 50;
	VerySetFunction(id,Very_Set_Text_CharSpace,0,0,0,0);
	VeryAddTextEx(id,xx,yy,"Word Space",RGB(0,0,255));
	VerySetFunction(id,Very_Set_Text_WordSpace,20,0,0,0);
	VeryAddTextEx(id,-1,-1,"Word Space",RGB(0,0,255));
	
	VerySetFunction(id,Very_Set_Text_WordSpace,0,0,0,0);
	VerySetFunction(id,Very_Set_Text_Rendering,0,0,0,0);
	VeryAddTextEx(id,xx,yy += 50,"Render0",RGB(0,0,255));
	VerySetFunction(id,Very_Set_Text_Rendering,1,0,0,0);
	VeryAddTextEx(id,xx,yy += 50,"Render1",RGB(0,0,255));
	VerySetFunction(id,Very_Set_Text_Rendering,2,0,0,0);
	VeryAddTextEx(id,xx,yy += 50,"Render2",RGB(0,0,255));
	VerySetFunction(id,Very_Set_Text_Rendering,3,0,0,0);
	VeryAddTextEx(id,xx,yy += 50,"Render3",RGB(0,0,255));
	VerySetFunction(id,Very_Set_Text_Rendering,4,0,0,0);
	VeryAddTextEx(id,xx,yy += 50,"Render4",RGB(0,0,255));

	//Close current page
	iret=VerySetFunction(id,Very_Set_NewOrClosePage,0,0,0,0);
}
void CharTable(long id)
{
	char buf[50];
static const int PAGE_WIDTH = 420;
static const int PAGE_HEIGHT = 400;
static const int CELL_WIDTH = 20;
static const int CELL_HEIGHT = 20;
static const int CELL_HEADER = 10;

	//new a page for b5
	VerySetFunction(id,Very_Set_NewOrClosePage,PAGE_WIDTH,PAGE_HEIGHT,0,0);
	
	// Draw vertical lines.
	for (int i = 0; i <= 17; i++) 
	{
		int x = i * CELL_WIDTH + 40;
		VeryAddLine(id,x,40,x,PAGE_HEIGHT - 60,1,RGB(0,0,0));
		if (i > 0 && i <= 16) 
		{
			sprintf(buf, "%X", i - 1);
			VeryAddTextEx(id,x + 5,40,buf,RGB(255,0,0));
		}
	}
	
	// Draw horizontal lines.
	for (int j = 0; j <= 15; j++)
	{
		int y = j * CELL_HEIGHT + 40;
		VeryAddLine(id,40,y,PAGE_WIDTH - 40,y,1,RGB(0,0,0));
		if (j < 14)
		{
			sprintf(buf, "%X", j+2);
			VeryAddTextEx(id,45,y + 20,buf,RGB(255,0,0));
		}
	}

	{
		int i, j;
		
		for (i = 1; i < 17; i++)
		{
			for (j = 1; j < 17; j++) 
			{
				//int y = PAGE_HEIGHT - 55 - ((i - 1) * CELL_HEIGHT);
				int y = (i * CELL_HEIGHT);
				int x = j * CELL_WIDTH + 45;
				
				buf[1] = 0x00;
				buf[0] = (i - 1) * 16 + (j - 1);
				if (buf[0] >= 32) 
				{
					VeryAddTextEx(id,x,y,buf,RGB(0,0,0));
				}
			}
		}
	}
	//Close this page
	VerySetFunction(id,Very_Set_NewOrClosePage,0,0,0,0);
}
void TextAppendFuncs(char *lpPDFFile)
{
	char szPDFFile[256];
	char szImageFile[256];
	long id;

	memset(szPDFFile,0,256);
	memset(szImageFile,0,256);

	strcpy(szPDFFile,lpPDFFile);
	id=VeryOpen(szPDFFile);
	if(id>0)
	{
		VeryAddInfo(id,"Title","Subject","Author","Keywords","Creator");
		VerySetFunction(id,Very_Set_ViewerPreferences,4+4096,2,0,0);

		//add image file types
		AddTIFFImage(id);

		AddJPGImage(id);
		
		AddWMFImage(id);
		
		//add bookmark
		VerySetFunction(id,Very_Set_BookMark,0,0,"bookmark three",0);

		AddText(id);

		AddLineAndRect(id);

		AddTextFile(id);

		AddTextExample2(id);

		CharTable(id);

		VeryClose(id);
	}
}
void TestPDFStampFuncs(char *lpPDFFile, BOOL bIsNewLayer)
{
	char szOutputFileName[MAX_PATH];

	long id = -1;
	if(bIsNewLayer)
	{
		GetModulePath(szOutputFileName, "_001-newlayer.pdf");
		id = VeryStampLayerOpen(lpPDFFile, szOutputFileName,"foreground", "background");
	}
	else
	{
		GetModulePath(szOutputFileName, "_001.pdf");
		id = VeryStampOpen(lpPDFFile, szOutputFileName);
	}
	if(id>0)
	{
		int page = 1;
		int pagecount = VeryStampGetFunction(id, Very_Get_PdfPageCount, 0, 0, 0, 0);
		for(page = 1; page <= pagecount; page++)
		{
			char m_szStampBuf[1024];
			int left = VeryStampGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "left", 0);
			int top = VeryStampGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "top", 0);
			int pagewidth = VeryStampGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "width", 0);
			int pageheight = VeryStampGetFunction(id, Very_Get_PageBoxForStamp, page, 0, "height", 0);
			
			VeryStampSetFunction(id, Very_Set_Range, page, 1, 0, 0);
			sprintf(m_szStampBuf,"Page:<%d>, Page Box: [%d %d %d %d]",pagecount-page+1,left,top,pagewidth,pageheight);
			VeryStampAddText(id, 2, m_szStampBuf,255,0,0,0,0,0,0,300,0,10,1,"http://www.verypdf.com",0);
		}
		VeryStampSetFunction(id, Very_Set_Range, 2, 2, 0,0);
		VeryStampAddImage(	id, 7, "logo.jpg",30,-30,0,0,0,0,0,0,0);
		VeryStampAddImage(	id, 3, "logo.jpg",-30,30,0,0,0,0,0,0,0);
		
		VeryStampAddImageEx(	id, 1, "logo.jpg",0,0,0,0,157*2,19*2,0,0,0);
		
		VeryStampAddRect(id, 100, 100, 150,150, 2, RGB(255,0,0),0,RGB(255,0,0));
		VeryStampAddRect(id, 100, 300, 150,350, 2, RGB(255,0,0),1,RGB(255,0,0));
		VeryStampAddRect(id, 100, 400, 150,450, 4, RGB(255,255,0),0,RGB(255,0,0));
		VeryStampAddRect(id, 100, 500, 150,550, 4, RGB(255,255,0),1,RGB(255,0,255));
		
		VeryStampAddLine(	id, 2, 1, RGB(255,0,0),
			0,80,0,0,
			80,0);
		VeryStampAddLine(	id, 6, 1, RGB(0,255,0),
			0,-80,0,0,
			80,0);
		VeryStampAddRectWithLayer(id, 200, 100, 250,150, 2, RGB(255,0,0),0,RGB(255,0,0),1);
		VeryStampAddRectWithLayer(id, 200, 300, 250,350, 2, RGB(255,0,0),1,RGB(255,0,0),1);
		VeryStampAddRectWithLayer(id, 200, 400, 250,450, 4, RGB(255,255,0),0,RGB(255,0,0),1);
		VeryStampAddRectWithLayer(id, 200, 500, 250,550, 4, RGB(255,255,0),1,RGB(255,0,255),1);
		
		VeryStampClose(id);
	}
	if(bIsNewLayer == FALSE)
	{
		char szFileName_Undo[MAX_PATH];
		GetModulePath(szFileName_Undo, "_001_undo.pdf");
		CopyFile(szOutputFileName, szFileName_Undo, FALSE);
		VeryStampUndo(szFileName_Undo);
	}
}
int TestImageStampFuncs()
{
	char szInTIFFName[MAX_PATH];
	GetModulePath(szInTIFFName,"multipage.tif");
	char szOutTIFFName[MAX_PATH];
	GetModulePath(szOutTIFFName,"example_stamp.tif");

	//Stamp text&image into a TIFF file, get info from a TIFF file, print a TIFF file
	if(1)
	{
		//Add a text stamp into TIFF file
		long id = ImageStampOpen(szInTIFFName,szOutTIFFName);
		if(id < 0)
			return 0;
		struct pdfshell2::LOGFONT m_font;
		memset(&m_font,0,sizeof(struct pdfshell2::LOGFONT));
		strcpy((char*)m_font.lfFaceName,"Arial");
		m_font.lfHeight = 200;
//		ImageStampAddText_VB(id,100,100,"This is a test!",RGB(0,0,0),0,200,0,"Arial");
//		ImageStampAddText_VB(id,100,500,"This is a test!",RGB(0,0,0),0,150,450,"Arial");
		ImageStampAddText(id,100,100,"This is a test!",RGB(0,0,0),m_font,0);
		
		m_font.lfEscapement = m_font.lfOrientation = 45*10;
		m_font.lfHeight = 150;
		ImageStampAddText(id,100,500,"This is a test!",RGB(0,0,0),m_font,1);

		//Add an image stamp into TIFF file
		char szInExampleName1[MAX_PATH];
		GetModulePath(szInExampleName1,"logo.jpg");
		ImageStampAddImage(id,0,0,100,100,szInExampleName1,TRUE);

		char szInExampleName2[MAX_PATH];
		GetModulePath(szInExampleName2,"test1.jpg");
		ImageStampAddImage(id,300,300,100,100,szInExampleName2,TRUE);

		ImageStampAddLine(id,100,100,800,800,5,RGB(255,0,0),PS_SOLID);

		ImageStampAddLine(id,100,500,800,800,10,RGB(0,0,0),PS_DASH);

		//Get Image Info from TIFF file
		struct pdfshell2::BITMAPINFOHEADER infoHeader;
		ImageStampGetInfo(id,&infoHeader);

		//Print Current TIFF Image
		ImageStampPrintEx(id,"docPrint",DMORIENT_PORTRAIT,DMPAPER_A4,3,0);

		HDC m_tmpDC = ImageStampGetHDC(id);
		if(m_tmpDC)
		{
			char *m_pText = "ImageStampGetHDC() Test...";
			TextOut(m_tmpDC,100,100,m_pText,strlen(m_pText));
			ImageStampReleaseHDC(id,m_tmpDC);
			m_tmpDC = NULL;
		}

		ImageStampClose(id);

		ShellExecute(NULL,"open",szOutTIFFName,NULL,NULL,SW_SHOWNORMAL);
	}
	MessageBox(NULL,"Please click any key to continue ...","Prompt",MB_OK);
	//Show a TIFF file and a PDF file
	{
		char szInExampleName1[MAX_PATH];
		GetModulePath(szInExampleName1,"example.pdf");
		long id = ImageStampOpen(szInExampleName1,NULL);
		if(id < 0)
			return 0;
		//Show PDF file on an output-device
		HDC hDC = GetDC(NULL);
		struct pdfshell2::RECT m_rectDest = {0,0,300,300};
		ImageStampShow(id,hDC,&m_rectDest,NULL);
		ReleaseDC(NULL,hDC);

		VeryShellPrintPDFFileTimeOut(2*1000);  //Check Printing status after 2 seconds
		VeryShellPrintPDFFileMargins(50);      //Set the margins to 50 point
		//Print Current PDF file
		ImageStampSetPageRange(id,"2,5"); //You can print a special page range at here
		ImageStampPrintEx(id,"docPrint",DMORIENT_LANDSCAPE,DMPAPER_A4,3,0);
		//Close PDF file and doesn't change anything
		ImageStampCloseAndNotSave(id);
	}
	return 0;
}

int main(int argc, _TCHAR* argv[])
{
	VeryInitializeLibrary();
	
	VeryStampReg("XXXXXXXXXXXXXXXXXXXXXXXXXXXXX");

	char szOutPDFFile[MAX_PATH];
	GetModulePath(szOutPDFFile, "_out.pdf");
	int id = VeryCreate(szOutPDFFile);
	VeryAddInfo(id, "Title", "Subject", "Author", "Keywords", "Creator");
	char szFileName[MAX_PATH];
	char drive[_MAX_DRIVE];
	char dir[_MAX_DIR];
	char fname[_MAX_FNAME];
	char ext[_MAX_EXT];
	GetModuleFileName(NULL,szFileName,MAX_PATH);
	_splitpath(szFileName, drive, dir, fname, ext );
	_makepath(szFileName, drive, dir, "multipage", ".tif");
	int nRet = VeryAddImage(id, szFileName);	
    VeryClose(id);

	float left, top, right, bottom;
	VeryGetPDFFileMediaBox(szOutPDFFile, 1, &left, &top, &right, &bottom);
	
	//Show a TIFF file and a PDF file
	{
		id = ImageStampOpen(szOutPDFFile,szOutPDFFile);
		if(id < 0)
			return 0;
		struct pdfshell2::BITMAPINFOHEADER bmbi;
		ImageStampGetInfo(id, &bmbi);
		//Show PDF file on an output-device
		HDC hDC = GetDC(NULL);
		struct pdfshell2::RECT destRect = {0,0,200,200};
		struct pdfshell2::RECT srcRect;
		srcRect.left = 0;
		srcRect.top = 0;
		srcRect.right = bmbi.biWidth;
		srcRect.bottom = bmbi.biHeight;
		ImageStampShow(id,hDC,&destRect,&srcRect);
		ReleaseDC(NULL,hDC);

		VeryShellPrintPDFFileTimeOut(2*1000);  //Check Printing status after 2 seconds
		VeryShellPrintPDFFileMargins(50);      //Set the margins to 50 point
		//Print Current PDF file
		ImageStampSetPageRange(id,"2"); //You can print a special page range at here
		ImageStampPrintEx(id,"docPrint",DMORIENT_LANDSCAPE,DMPAPER_A4,3, 0);
		//Close PDF file and doesn't change anything
		ImageStampCloseAndNotSave(id);
	}

	TextAppendFuncs(szOutPDFFile);
	TestPDFStampFuncs(szOutPDFFile, FALSE);
	TestPDFStampFuncs(szOutPDFFile, TRUE);
	TestImageStampFuncs();
	VeryShellPrintPDFFileEx(szOutPDFFile,"docPrint",DMORIENT_LANDSCAPE,DMPAPER_A4,3,0);
	VeryUninitializeLibrary();
	return 0;
}

