#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <io.h>

typedef long (__stdcall *ImageStampOpenFunc)(char *In,char *Out);
typedef void (__stdcall *ImageStampCloseFunc)(long id);
typedef long (__stdcall *ImageStampCloseAndNotSaveFunc)(long id);
typedef long (__stdcall *ImageStampPrintFunc)(long id,const char *ptrPrintName,long dmOrientation, long dmPaperSize,long dmCopies);
typedef long (__stdcall *ImageStampPrintExFunc)(long id,const char *ptrPrintName,long dmOrientation, long dmPaperSize,long dmCopies, int bShellPrint);

typedef long (__stdcall *VeryShellPrintPDFFileFunc)(const char *lpPDFFileName,const char *ptrPrintName,
												long dmOrientation, long dmPaperSize,long dmCopies);
typedef long (__stdcall *VeryShellPrintPDFFileExFunc)(const char *lpPDFFileName,const char *ptrPrintName,
												long dmOrientation, long dmPaperSize,long dmCopies,int bShellPrint);
typedef long (__stdcall *VeryShellPrintPDFFileTimeOutFunc)(DWORD dwMilliseconds);
typedef long (__stdcall *VeryShellPrintPDFFileMarginsFunc)(long lMargins);
/*
dmOrientation

	Selects the orientation of the paper. This member can be either DMORIENT_PORTRAIT 
	(1) or DMORIENT_LANDSCAPE (2).

dmPaperSize
	Selects the size of the paper to print on, the dmPaperSize member can 
	be set to one of the following predefined values: 

DMPAPER_LETTER		        Letter, 8 1/2 by 11 inches             																																		
DMPAPER_LEGAL		        Legal, 8 1/2 by 14 inches              																																		
DMPAPER_A4		        A4 Sheet, 210 by 297 millimeters       																																		
DMPAPER_CSHEET		        C Sheet, 17 by 22 inches               																																		
DMPAPER_DSHEET		        D Sheet, 22 by 34 inches               																																		
DMPAPER_ESHEET		        E Sheet, 34 by 44 inches               																																		
DMPAPER_LETTERSMALL	        Letter Small, 8 1/2 by 11 inches       																																		
DMPAPER_TABLOID		        Tabloid, 11 by 17 inches               																																		
DMPAPER_LEDGER		        Ledger, 17 by 11 inches                																																		
DMPAPER_STATEMENT	        Statement, 5 1/2 by 8 1/2 inches       																																		
DMPAPER_EXECUTIVE	        Executive, 7 1/4 by 10 1/2 inches      																																		
DMPAPER_A3		        A3 sheet, 297 by 420 millimeters       																																		
DMPAPER_A4SMALL		        A4 small sheet, 210 by 297 millimeters 																																		
DMPAPER_A5		        A5 sheet, 148 by 210 millimeters       																																		
DMPAPER_B4		        B4 sheet, 250 by 354 millimeters       																																		
DMPAPER_B5		        B5 sheet, 182-by-257-millimeter paper  																																		
DMPAPER_FOLIO		        Folio, 8-1/2-by-13-inch paper          																																		
DMPAPER_QUARTO		        Quarto, 215-by-275-millimeter paper    																																		
DMPAPER_10X14		        10-by-14-inch sheet                    																																		
DMPAPER_11X17		        11-by-17-inch sheet                    																																		
DMPAPER_NOTE		        Note, 8 1/2 by 11 inches               																																		
DMPAPER_ENV_9		        #9 Envelope, 3 7/8 by 8 7/8 inches     																																		
DMPAPER_ENV_10		        #10 Envelope, 4 1/8 by 9 1/2 inches    																																		
DMPAPER_ENV_11		        #11 Envelope, 4 1/2 by 10 3/8 inches   																																		
DMPAPER_ENV_12		        #12 Envelope, 4 3/4 by 11 inches       																																		
DMPAPER_ENV_14		        #14 Envelope, 5 by 11 1/2 inches       																																		
DMPAPER_ENV_DL		        DL Envelope, 110 by 220 millimeters    																																		
DMPAPER_ENV_C5		        C5 Envelope, 162 by 229 millimeters    																																		
DMPAPER_ENV_C3		        C3 Envelope,  324 by 458 millimeters   																																		
DMPAPER_ENV_C4		        C4 Envelope,  229 by 324 millimeters   																																		
DMPAPER_ENV_C6		        C6 Envelope,  114 by 162 millimeters   																																		
DMPAPER_ENV_C65		        C65 Envelope, 114 by 229 millimeters   																																		
DMPAPER_ENV_B4		        B4 Envelope,  250 by 353 millimeters   																																		
DMPAPER_ENV_B5		        B5 Envelope,  176 by 250 millimeters   																																		
DMPAPER_ENV_B6		        B6 Envelope,  176 by 125 millimeters   																																		
DMPAPER_ENV_ITALY	        Italy Envelope, 110 by 230 millimeters 																																		
DMPAPER_ENV_MONARCH	        Monarch Envelope, 3 7/8 by 7 1/2 inches																																		
DMPAPER_ENV_PERSONAL	        6 3/4 Envelope, 3 5/8 by 6 1/2 inches  																																		
DMPAPER_FANFOLD_US		US Std Fanfold, 14 7/8 by 11 inches
DMPAPER_FANFOLD_STD_GERMAN	German Std Fanfold, 8 1/2 by 12 inches
DMPAPER_FANFOLD_LGL_GERMAN	German Legal Fanfold, 8 1/2 by 13 inches 
*/

HMODULE							g_hVeryW=NULL;

ImageStampOpenFunc				ImageStampOpen;
ImageStampCloseFunc				ImageStampClose;
ImageStampCloseAndNotSaveFunc	ImageStampCloseAndNotSave;
ImageStampPrintFunc				ImageStampPrint;
ImageStampPrintExFunc			ImageStampPrintEx;

VeryShellPrintPDFFileFunc		VeryShellPrintPDFFile;
VeryShellPrintPDFFileExFunc		VeryShellPrintPDFFileEx;
VeryShellPrintPDFFileTimeOutFunc VeryShellPrintPDFFileTimeOut;
VeryShellPrintPDFFileMarginsFunc VeryShellPrintPDFFileMargins;
void GetModulePath(char *out_path,char *in_name)
{
	char *p;
	GetModuleFileName(NULL,out_path,256);
	p =strrchr(out_path,'\\');
	p[1]=0;
	strcat(out_path,in_name);
}
void FreeVeryWDll()
{
	if(g_hVeryW==NULL)
		return ;
	FreeLibrary(g_hVeryW);
	g_hVeryW=NULL;
}

BOOL LoadVeryWDll()
{
	char path[_MAX_PATH];
	GetModulePath(path,"verywrite.dll");
	g_hVeryW=LoadLibrary(path);
	if(g_hVeryW==NULL)
		goto Failer;

	ImageStampOpen = (ImageStampOpenFunc)GetProcAddress(g_hVeryW,"ImageStampOpen");
	if(ImageStampOpen == NULL)
		goto Failer;
	ImageStampClose = (ImageStampCloseFunc)GetProcAddress(g_hVeryW,"ImageStampClose");
	if(ImageStampClose == NULL)
		goto Failer;
	ImageStampPrint = (ImageStampPrintFunc)GetProcAddress(g_hVeryW,"ImageStampPrint");
	if(ImageStampPrint == NULL)
		goto Failer;
	ImageStampPrintEx = (ImageStampPrintExFunc)GetProcAddress(g_hVeryW,"ImageStampPrintEx");
	if(ImageStampPrintEx == NULL)
		goto Failer;
	ImageStampCloseAndNotSave = (ImageStampCloseAndNotSaveFunc)GetProcAddress(g_hVeryW,"ImageStampCloseAndNotSave");
	if(ImageStampCloseAndNotSave == NULL)
		goto Failer;

	VeryShellPrintPDFFile = (VeryShellPrintPDFFileFunc)GetProcAddress(g_hVeryW,"VeryShellPrintPDFFile");
	if(VeryShellPrintPDFFile == NULL)
		goto Failer;
	VeryShellPrintPDFFileEx = (VeryShellPrintPDFFileExFunc)GetProcAddress(g_hVeryW,"VeryShellPrintPDFFileEx");
	if(VeryShellPrintPDFFileEx == NULL)
		goto Failer;
	VeryShellPrintPDFFileTimeOut = (VeryShellPrintPDFFileTimeOutFunc)GetProcAddress(g_hVeryW,"VeryShellPrintPDFFileTimeOut");
	if(VeryShellPrintPDFFileTimeOut == NULL)
		goto Failer;
	VeryShellPrintPDFFileMargins = (VeryShellPrintPDFFileMarginsFunc)GetProcAddress(g_hVeryW,"VeryShellPrintPDFFileMargins");
	if(VeryShellPrintPDFFileMargins == NULL)
		goto Failer;

	return TRUE;
Failer:
	FreeVeryWDll(); 
	return FALSE;

}

int PrintPDFMethod1(char *lpPDFFile)
{
	long id = ImageStampOpen(lpPDFFile,NULL);
	if(id < 0)
		return 0;
	ImageStampPrintEx(id,"docPrint",DMORIENT_LANDSCAPE,DMPAPER_A4,1,0);
	ImageStampCloseAndNotSave(id);
	return 1;
}

int main(int argc, char* argv[])
{
	if(argc != 3)
	{
		printf("Usage: \"%s\" \"PDFFileName\" \"Printer Name\"\n",argv[0]);
		return 0;
	}
	if(!LoadVeryWDll())
		return 0;
	
//	PrintPDFMethod1("C:\\Handle Bar Complete Drawing.SLDDRW.1.PDF");

	VeryShellPrintPDFFileTimeOut(2*1000); //Set timeout to 30 seconds
	VeryShellPrintPDFFileMargins(50);
	//Print PDF file
	int iRet = VeryShellPrintPDFFile(argv[1],argv[2],DMORIENT_PORTRAIT,DMPAPER_A4,1);
	//int iRet = VeryShellPrintPDFFileEx(argv[1],argv[2],DMORIENT_PORTRAIT,DMPAPER_A4,1,FALSE);
	FreeVeryWDll();
	return 0;
}
